# Class ExplodedStarTable

java.lang.Object
uk.ac.starlink.table.WrapperStarTable
uk.ac.starlink.table.ExplodedStarTable

All Implemented Interfaces:
  `Closeable, AutoCloseable, StarTable`

public class ExplodedStarTable extends WrapperStarTable
Wrapper table which takes any column whose value is N-element arrays and turns it into N scalar-valued columns.

Since:
  2 Mar 2005
Author:
  Mark Taylor (Starlink)

## Field Summary

### Fields inherited from class WrapperStarTable

`baseTable`

## Constructor Summary

Constructors
Constructor
Description
`ExplodedStarTable(StarTable baseTable)`
Constructs a table in which all fixed-length array-valued columns are exploded.
`ExplodedStarTable(StarTable baseTable, boolean[] colFlags)`
Constructs a table in which specified columns are exploded.

## Method Summary

Modifier and Type
Method
Description
`Object`
`getCell(long irow, int icol)`
Returns the contents of a given table cell.
`int`
`getColumnCount()`
Returns the number of columns in this table.
`ColumnInfo`
`getColumnInfo(int icol)`
Returns the object describing the data in a given column.
`Object[]`
`getRow(long irow)`
Returns the contents of a given table row.
`RowAccess`
`getRowAccess()`
Returns an object which can provide random access to this table's data, if random access is implemented.
`RowSequence`
`getRowSequence()`
Returns an object which can iterate over all the rows in the table sequentially.
`RowSplittable`
`getRowSplittable()`
Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.

### Methods inherited from class WrapperStarTable

`checkedLongToInt, close, getBaseTable, getColumnAuxDataInfos, getName, getParameterByName, getParameters, getRowCount, getURL, isRandom, setName, setParameter, setURL, toString`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ExplodedStarTable

public ExplodedStarTable(StarTable baseTable, boolean[] colFlags)
Constructs a table in which specified columns are exploded. All of the specified columns must have values which are fixed-length arrays.

Parameters:
  `baseTable` - base table
  `colFlags` - array of flags the same length as the number of columns in `baseTable`; true elements indicate columns in the base table which should be exploded
Throws:
  `IllegalArgumentException` - if any column specified by `colFlags` has a type which is not a fixed-length array

### ExplodedStarTable

public ExplodedStarTable(StarTable baseTable)
Constructs a table in which all fixed-length array-valued columns are exploded.

Parameters:
  `baseTable` - base table

## Method Details

### getColumnCount

public int getColumnCount()
Description copied from interface: `StarTable`
Returns the number of columns in this table.

Specified by:
  `getColumnCount` in interface `StarTable`
Overrides:
  `getColumnCount` in class `WrapperStarTable`
Returns:
  the number of columns

### getColumnInfo

public ColumnInfo getColumnInfo(int icol)
Description copied from interface: `StarTable`
Returns the object describing the data in a given column.

Specified by:
  `getColumnInfo` in interface `StarTable`
Overrides:
  `getColumnInfo` in class `WrapperStarTable`
Parameters:
  `icol` - the column for which header information is required
Returns:
  a ValueInfo object for column `icol`

### getCell

public Object getCell(long irow, int icol) throws IOException
Description copied from interface: `StarTable`
Returns the contents of a given table cell. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`.

This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

Specified by:
  `getCell` in interface `StarTable`
Overrides:
  `getCell` in class `WrapperStarTable`
Parameters:
  `irow` - the index of the cell's row
  `icol` - the index of the cell's column
Returns:
  the contents of this cell
Throws:
  `IOException` - if there is an error reading the data

### getRow

public Object[] getRow(long irow) throws IOException
Description copied from interface: `StarTable`
Returns the contents of a given table row. The returned value is equivalent to an array formed of all the objects returned by `getCell(irow,icol)` for all the columns `icol` in sequence.

This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

Specified by:
  `getRow` in interface `StarTable`
Overrides:
  `getRow` in class `WrapperStarTable`
Parameters:
  `irow` - the index of the row to retrieve
Returns:
  an array of the objects in each cell in row `irow`
Throws:
  `IOException` - if there is an error reading the data

### getRowSequence

public RowSequence getRowSequence() throws IOException
Description copied from interface: `StarTable`
Returns an object which can iterate over all the rows in the table sequentially. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.

Specified by:
  `getRowSequence` in interface `StarTable`
Overrides:
  `getRowSequence` in class `WrapperStarTable`
Returns:
  new RowSequence
Throws:
  `IOException` - if there is an error providing access

### getRowAccess

public RowAccess getRowAccess() throws IOException
Description copied from interface: `StarTable`
Returns an object which can provide random access to this table's data, if random access is implemented. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.

Specified by:
  `getRowAccess` in interface `StarTable`
Overrides:
  `getRowAccess` in class `WrapperStarTable`
Returns:
  new RowAccess
Throws:
  `IOException` - if there is an error setting up access

### getRowSplittable

public RowSplittable getRowSplittable() throws IOException
Description copied from interface: `StarTable`
Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.

The return value must be non-null, and may provide splitting arrangements specially appropriate for the implementation. If this table 'wraps' an upstream table, it is usually best to base the implementation on calls to the the upstream `getRowSplittable` method, so that upstream policy about how to divide up the table is respected. However, implementations without special requirements may return `Tables.getDefaultRowSplittable``(this)`.

Specified by:
  `getRowSplittable` in interface `StarTable`
Overrides:
  `getRowSplittable` in class `WrapperStarTable`
Returns:
  new RowSplittable
Throws:
  `IOException`
See Also:
  - `RowRunner`